package fowler;

public class AlbumClient {
	public static void main(java.lang.String[] args) throws java.lang.Exception {
		fowler.AlbumClient client = new fowler.AlbumClient();
		client.printAlbumInfo();
		client.isPlatinumAlbum();
		client.createAlbum();
		client.playSingleAlbum();
		client.paperExample();
	}

	public void paperExample() {
		brmi.Service musicService = new brmi.Service("music-service",
				fowler.Music.class);
		try {
			// Remote part
			brmi.Service service$ = musicService;
			brmi.Batch batch$ = service$.getRoot();
			brmi.Handle album$77847 = batch$.doInvoke(batch$, "getAlbum",
					new Class[] { java.lang.String.class },
					new Object[] { "1" });
			brmi.Handle var$0 = batch$.doInvoke(batch$.doInvoke(album$77847,
					"getTitle", new Class[] {}, new Object[] {}), "startsWith",
					new Class[] { java.lang.String.class },
					new Object[] { "A" });
			batch$.rIf(var$0);
			brmi.cursor.Cursor t$90132$Cursor = batch$.makeCursor(batch$
					.doInvoke(album$77847, "getTracks", new Class[] {},
							new Object[] {}));
			brmi.Handle var$1 = t$90132$Cursor.doInvoke(t$90132$Cursor,
					"getTitle", new Class[] {}, new Object[] {});
			batch$.rElse();
			brmi.Handle var$2 = batch$.doInvoke(batch$.doInvoke(album$77847,
					"getArtist", new Class[] {}, new Object[] {}), "getName",
					new Class[] {}, new Object[] {});
			batch$.rEnd();
			batch$.flush();

			// Local part

			// Remote Variable: album --> album$77847
			if ((java.lang.Boolean) var$0.get()) {
				java.lang.System.out.println("Tracks:");
				while (t$90132$Cursor.next()) {
					java.lang.System.out.print(' ');
					java.lang.System.out.print((java.lang.String) var$1.get());
				}
			} else {
				java.lang.System.out.print("Album is not platinum: "
						+ (java.lang.String) var$2.get());
			}
		} catch (Throwable t) {
			throw new RuntimeException(t);
		}
	}

	public void printAlbumInfo() {
		brmi.Service musicService = new brmi.Service("music-service",
				fowler.Music.class);
		try {
			// Remote part
			brmi.Service service$ = musicService;
			brmi.Batch batch$ = service$.getRoot();
			brmi.Handle album$147479 = batch$.doInvoke(batch$, "getAlbum",
					new Class[] { java.lang.String.class },
					new Object[] { "1" });
			brmi.Handle var$3 = batch$.doInvoke(album$147479, "getTitle",
					new Class[] {}, new Object[] {});
			brmi.Handle var$4 = batch$.doInvoke(batch$.doInvoke(album$147479,
					"getArtist", new Class[] {}, new Object[] {}), "getName",
					new Class[] {}, new Object[] {});
			batch$.flush();

			// Local part

			// Remote Variable: album --> album$147479
			java.lang.System.out.println("Title: "
					+ (java.lang.String) var$3.get());
			java.lang.System.out.println("Artist: "
					+ (java.lang.String) var$4.get());
		} catch (Throwable t) {
			throw new RuntimeException(t);
		}
	}

	public void isPlatinumAlbum() {
		brmi.Service musicService = new brmi.Service("music-service",
				fowler.Music.class);
		try {
			// Remote part
			brmi.Service service$ = musicService;
			brmi.Batch batch$ = service$.getRoot();
			brmi.Handle album$184343 = batch$.doInvoke(batch$, "getAlbum",
					new Class[] { java.lang.String.class },
					new Object[] { "1" });
			brmi.Handle var$5 = batch$.binary(brmi.Bops.And, batch$
					.doInvoke(album$184343, "isPlatinum", new Class[] {},
							new Object[] {}), batch$.doInvoke(batch$.doInvoke(
					album$184343, "getTitle", new Class[] {}, new Object[] {}),
					"startsWith", new Class[] { java.lang.String.class },
					new Object[] { "A" }));
			batch$.rIf(var$5);
			brmi.Handle var$6 = batch$.doInvoke(album$184343, "play",
					new Class[] {}, new Object[] {});
			brmi.Handle var$7 = batch$.doInvoke(album$184343, "getTitle",
					new Class[] {}, new Object[] {});
			batch$.rElse();
			brmi.Handle var$8 = batch$.doInvoke(batch$.doInvoke(album$184343,
					"getArtist", new Class[] {}, new Object[] {}), "getName",
					new Class[] {}, new Object[] {});
			batch$.rEnd();
			batch$.flush();

			// Local part

			// Remote Variable: album --> album$184343
			if ((java.lang.Boolean) var$5.get()) {
				var$6.checkThrowable();
				java.lang.System.out.print("Album is platinum: "
						+ (java.lang.String) var$7.get());
			} else {
				java.lang.System.out.print("Album is not platinum: "
						+ (java.lang.String) var$8.get());
			}
		} catch (Throwable t) {
			throw new RuntimeException(t);
		}
	}

	public void createAlbum() {
		brmi.Service musicService = new brmi.Service("music-service",
				fowler.Music.class);
		try {
			// Remote part
			brmi.Service service$ = musicService;
			brmi.Batch batch$ = service$.getRoot();
			brmi.Handle album$241687 = batch$.doInvoke(batch$, "createAlbum",
					new Class[] { java.lang.String.class,
							java.lang.String.class }, new Object[] { "2",
							"First Album" });
			brmi.Handle var$9 = batch$.doInvoke(album$241687, "setPlatinum",
					new Class[] { boolean.class }, new Object[] { true });
			brmi.Handle artist$249881 = batch$.doInvoke(batch$, "addArtist",
					new Class[] { java.lang.String.class,
							java.lang.String.class }, new Object[] { "2",
							"John Smith" });
			brmi.Handle var$10 = batch$.doInvoke(album$241687, "setArtist",
					new Class[] { fowler.Artist.class },
					new Object[] { artist$249881 });
			brmi.Handle track$258071 = batch$.doInvoke(batch$, "createTrack",
					new Class[] { java.lang.String.class },
					new Object[] { "First track" });
			brmi.Handle var$11 = batch$.doInvoke(track$258071, "addPerformer",
					new Class[] { fowler.Artist.class },
					new Object[] { artist$249881 });
			brmi.Handle var$12 = batch$.doInvoke(album$241687, "addTrack",
					new Class[] { fowler.Track.class },
					new Object[] { track$258071 });
			batch$.flush();

			// Local part

			// Remote Variable: album --> album$241687
			var$9.checkThrowable();
			// Remote Variable: artist --> artist$249881
			var$10.checkThrowable();
			// Remote Variable: track --> track$258071
			var$11.checkThrowable();
			var$12.checkThrowable();
		} catch (Throwable t) {
			throw new RuntimeException(t);
		}
	}

	public void playSingleAlbum() {
		brmi.Service musicService = new brmi.Service("music-service",
				fowler.Music.class);
		try {
			// Remote part
			brmi.Service service$ = musicService;
			brmi.Batch batch$ = service$.getRoot();
			brmi.Handle album$294935 = batch$.doInvoke(batch$, "getAlbum",
					new Class[] { java.lang.String.class },
					new Object[] { "1" });
			brmi.cursor.Cursor t$303122$Cursor = batch$.makeCursor(batch$
					.doInvoke(album$294935, "getTracks", new Class[] {},
							new Object[] {}));
			brmi.Handle var$13 = t$303122$Cursor.doInvoke(t$303122$Cursor,
					"getTitle", new Class[] {}, new Object[] {});
			brmi.cursor.Cursor a$319509$Cursor = t$303122$Cursor
					.makeCursor(t$303122$Cursor.doInvoke(t$303122$Cursor,
							"getPerformers", new Class[] {}, new Object[] {}));
			brmi.Handle var$14 = a$319509$Cursor.doInvoke(a$319509$Cursor,
					"getName", new Class[] {}, new Object[] {});
			brmi.Handle var$15 = batch$.doInvoke(album$294935, "play",
					new Class[] {}, new Object[] {});
			batch$.flush();

			// Local part

			// Remote Variable: album --> album$294935
			java.lang.System.out.println("Tracks: ");
			while (t$303122$Cursor.next()) {
				java.lang.System.out.print((java.lang.String) var$13.get());
				java.lang.System.out.println(',');
				java.lang.System.out.print("Performed by: ");
				while (a$319509$Cursor.next()) {
					java.lang.System.out.print((java.lang.String) var$14.get());
					java.lang.System.out.print(' ');
				}
				java.lang.System.out.print('\n');
			}
			java.lang.System.out.println("Song: "
					+ (java.lang.String) var$15.get());
		} catch (Throwable t) {
			throw new RuntimeException(t);
		}
	}

	public AlbumClient() {
		super();
	}
}
